package backfetch

import "fmt"

// Flow data
type Flow struct {
	Err      error
	registry *Registry

	nodes []Node
}

// NewFlow creates new flow
func NewFlow(r *Registry) *Flow {
	return &Flow{nil, r, []Node{}}
}

// Get node to flow
func (f *Flow) Get(name string, params ...interface{}) Node {
	if f.Err != nil {
		return nil
	}
	n, err := f.registry.Create(name, params...)
	if err != nil {
		f.Err = fmt.Errorf("Node: %s %s", name, err)
	}
	return n
}
