package backfetch_test

import (
	"flow/x/backfetch"
	"log"
	"reflect"
	"testing"

	vecasm "github.com/gohxs/vec-benchmark/asm"
)

func TestDev(t *testing.T) {
	// App initialization register all the named funcs
	reg := backfetch.NewRegistry()
	reg.Register("mul", vecMul) // Create Nodes
	reg.Register("ptr", ptr)

	f := backfetch.NewFlow(reg)
	{

		arr := []float32{1, 2, 3, 4}
		p := f.Get("ptr", &arr)
		n := f.Get("mul", []float32{1, 2, 3}, p)
		n2 := f.Get("mul", n, []float32{3, 3, 3})
		n3 := f.Get("mul", arr, arr)
		if f.Err != nil {
			t.Fatal("Error getting nodes", f.Err)
		}
		log.Println("Result:", p.Process(), n.Process(), n2.Process(), n3.Process())
		log.Println("node:", n3)
	}
	{
		// Manual nodes
		p := f.Get("mul", []float32{1, 2, 3}, &NodeManual{})
		log.Println("Res:", p)

	}

}

// Prepare an node with 2 inputs one output?
func vecMul(a, b []float32) []float32 {
	sz := len(a)
	if bsz := len(b); bsz < sz {
		sz = bsz
	}
	out := make([]float32, sz)
	vecasm.VecMulf32x8(a, b, out)
	return out
}

func ptr(a interface{}) interface{} {
	return reflect.ValueOf(a).Elem().Interface()
}

type NodeManual struct {
	/*whatever*/
}

func (n *NodeManual) Process() backfetch.Data {
	return []float32{1, 2, 3}
}
func (n *NodeManual) Type() reflect.Type {
	return reflect.TypeOf(([]float32)(nil))
}

/*
func TestMain(t *testing.T) {
	// Register all node factories
	reg := backfetch.NewRegistry()

	// Register step only registers a func with a name
	reg.Register("ptr", backfetch.NewPtr)
	reg.Register("const", backfetch.NewConstNode)
	reg.Register("mul", vecMul)

	// Get step prepares function with input
	// which makes verifications
	f := backfetch.NewFlow(reg)

	arr := []float32{1, 2, 3} // Ptr
	a := f.Get("ptr", &arr)
	b := f.Get("const", []float32{1, 2, 3, 4, 5, 6, 7, 8, 9, 10})
	m1 := f.Get("mul", a, b)
	m2 := f.Get("mul", m1, b)
	if f.Err != nil {
		t.Fatal(f.Err)
	}
	res := m1.Process()
	log.Println(res)

	t.Log("Adding element to ptr array")
	arr = append(arr, 4)
	log.Println("m1:", m1.Process())

	t.Log("Testing m2:", m2.Process())

}

func TestStruct(t *testing.T) {

}*/
