package flow

import "reflect"

// Serializable
type opConst struct {
	value Data
}

func (o *opConst) Process() Data {
	return o.value
}

func (o *opConst) Spec() OpSpec {
	return OpSpec{ // No inputs
		Name:       "const",
		OutputType: reflect.TypeOf(o.value),
	}
}

func Const(v Data) Operation {
	return &opConst{
		value: v,
	}
}
