package flow

import "log"

type Serialize struct {
	ops     []Operation    // Temp ops
	dataOps map[int]opData // Serialize this
}

type opData struct {
	Name  string      `json:"name"`
	In    []int       `json:"in,omitempty"`
	Value interface{} `json:"value,omitempty"`
}

// Fill up ops structure
func (s *Serialize) serialize(op Operation) int {
	// Recurse operations into an array
	// Find operationID
	if op == nil {
		log.Println("Op is nil")
		return -1
	}

	opId := -1
	for i, o := range s.ops {
		if o == op {
			opId = i
			break
		}
	}
	if opId == -1 {
		s.ops = append(s.ops, op)
		opId = len(s.ops) - 1
	}

	ret := opId
	od := opData{In: []int{}, Name: op.Spec().Name}

	switch o := op.(type) {
	case *opHandler:
		for _, in := range o.inputs {
			od.In = append(od.In, s.serialize(in))
		}
		break
	case *opConst:
		od.Value = o.value
		break

	}
	// Store in dataOps
	s.dataOps[ret] = od
	return ret
}

/*type Serialize struct {
	flows map[string]flowData
}
type opData struct {
	Name   string      `json:",omitempty"`
	Inputs []opData    `json:",omitempty"`
	Value  interface{} `json:",omitempty"`
}

type flowData struct {
	Param    map[string]interface{}
	Operator opData
}

func (s *Serialize) serialize(v interface{}) opData {
	//Create ID
	o, ok := v.(Operation)
	if !ok {
		return opData{Name: "const", Value: v}
	}
	// If it is a flow
	ret := opData{
		Name: o.Spec().Name,
	}
	// If flow
	if h, ok := o.(*opHandler); ok {
		for _, in := range h.inputs {
			r := s.serialize(in)
			if f, ok := in.(*Flow); ok {
				ret.Inputs = append(ret.Inputs, opData{Name: "@" + f.name})
			} else {
				ret.Inputs = append(ret.Inputs, r)
			}
		}
	}
	if f, ok := v.(*Flow); ok {

		fd := flowData{Param: map[string]interface{}{}, Operator: s.serialize(f.op)}
		for k, p := range f.params {
			fd.Param[k] = p
		}
		s.flows[f.name] = fd
	}

	return ret
}

func (s *Serialize) Serialize(f *Flow) string {
	s.serialize(f)

	ret := bytes.NewBuffer(nil)

	e := json.NewEncoder(ret)
	e.SetIndent("", " ")
	e.Encode(s.flows)

	return ret.String()
}*/
