package flow

// Graph the graph of operations
type Graph struct {
	flow *Flow
	// built operations
	// Caching operation
	operations []operation
}

// Run functions
func (g *Graph) Run(refs ...Ref) ([]Data, error) {
	res := []Data{}
	for _, r := range refs {
		switch ref := r.(type) {
		case RefConst:
			res = append(res, g.flow.consts[ref.id])
		case RefVar:
			res = append(res, g.flow.data[ref.id])
		case RefFunc:
			res = append(res, g.operations[ref.id].Process())
		default:
			// Invalid operation
			return nil, ErrOperation
		}
	}
	return res, nil
}
