package flow

import "reflect"

// Operation interface
type operation interface {
	// Set inputs?
	//Init(inputs ...interface{}) error
	Process() Data
}

////////////////////////////////////////////
// OP CONST
//////////////////////////////////////////

// Const should point to flow somehow?
/*type opConst struct {
	// Flow ref?
	value Data
}

func (o *opConst) Process() Data { return o.value }*/

/////////////////////////////////
// OP VARIABLE
///////////////////////////////////
type opVar struct {
	flow *Flow
	id   int
}

func (o *opVar) Process() Data {
	return o.flow.data[o.id]
}

///////////////////////////////////////////
// function operation
///////////////////////////

// Operation controller
// Operator for thing
type opFunc struct {
	flow     *Flow
	inputs   []operation // should be an operation
	executor interface{} // Function that executes, something like func(...inputs)
	// maybe cache
}

func (o *opFunc) Init(params ...interface{}) error {
	// Create Node list for param
	o.inputs = make([]operation, len(params))
	for i, p := range params {
		switch v := p.(type) {
		// if node executor
		case operation:
			o.inputs[i] = v
		default: // Check if pointer too
			//opParam[i] = Const(v) // Or the simple value?
		}
	}
	// Do checks here
	return nil
}

func (o *opFunc) Process() Data {
	// Cache control?
	callParam := make([]reflect.Value, len(o.inputs))
	for i, in := range o.inputs {
		switch v := in.(type) {
		case operation:
			callParam[i] = reflect.ValueOf(v.Process())
		default: // {lpf} Analyse this
			callParam[i] = reflect.ValueOf(v)
		}
	}

	return reflect.ValueOf(o.executor).Call(callParam)[0].Interface()

}
