package main

import (
	"flow"
	"log"
	"math/rand"
)

func main() {
	// Prepare registry
	reg() // Initialize register

	// Define operations
	// Several flows
	// Model a flow
	nn := flow.New("neural")
	nn.Op("vecrand", 10)

	res := nn.Run()
	log.Println(res)

}

func reg() {
	flow.Register("vecrand", normFloat)
}

// Generate random floats
func normFloat(sz int) []float32 {
	out := make([]float32, sz)

	for i := range out {
		out[i] = rand.Float32() // 0 to 1?
	}

	return out
}
