package main

import (
	"flow"
	"io/ioutil"
	"log"
	"math/rand"
	"net/http"
	"time"

	"github.com/gohxs/prettylog"
)

func main() {
	prettylog.Global()
	rand.Seed(int64(time.Now().Nanosecond()))

	flow.Register("randpick", randpick)
	flow.Register("httpget", httpget)

	urls := []string{
		"http://www.bing.com/?q=test",
		"http://www.google.com/?q=test",
	}

	f := flow.New()
	//	urlsVar := f.Variable(urls)

	single := f.Op("randpick", f.In(0))
	doget := f.Op("httpget", single)
	res := doget.Process(urls)
	log.Println("f:", f)

	//res, err := f.Run(doget)
	//if err != nil {
	//	log.Fatal(err)
	//}
	log.Println("Result:", res)

}

func randpick(s []string) string {
	log.Println("Picking between:", s)
	pick := rand.Intn(len(s))
	log.Println("Picking:", pick, s[pick], len(s))
	return s[pick]
}

// Get body
func httpget(s string) string {

	res, err := http.Get(s)
	if err != nil { // Error stater
		return ""
	}
	defer res.Body.Close()

	data, err := ioutil.ReadAll(res.Body)
	if err != nil {
		return ""
	}

	return string(data)

}
